#!/usr/bin/perl



$DB_DIR_NAME = $ARGV[0];

$DB_FILE_NAME = $DB_DIR_NAME . "/printers_db.txt";

open(DB_FILE, ">$DB_FILE_NAME") or die "Unable to open file $DB_FILE_NAME\n";
close DB_FILE;
main();

exit 0;
# finished


sub main
{
        `touch hello_world.file`;
        processDir($DB_DIR_NAME);
}

sub processDir
{
        my ($dir) = @_;

        opendir(DIR, $dir) or die "Unable to open dir $dir\n";
        my @dir_list = readdir(DIR);
        closedir(DIR) or die "Unable to close dir $dir\n";

        print "Processing dir $dir ($#dir_list entries)\n";

        my $entry;
        my $index = 0;
        for ($index = 0; $index <= $#dir_list; $index++ )
        {
                $entry = $dir_list[$index];

                my $path;
                if ($dir eq ".")
                {
                        # Only a filename
                        $path = $entry;
                }
                else
                {
                        $path = $dir."/".$entry;
                }

                if ( $entry eq "." || $entry eq ".." )
                {
                        #print "Skipping file $entry\n";
                        next;
                }

                if (-d $path)
                {
                        processDir($path);
                }
                elsif ( -f $path && $entry =~ /\.ppd$/)
                {
                        processPpdFile($path);
                }
                else
                {
                        #print "Not treating $path\n";
                }
        }

}


sub processPpdFile
{
        my ($entry) = @_;

        #print "Processing file $entry\n";

        open(DB_FILE, ">>$DB_FILE_NAME") or die "Unable to open file $DB_FILE_NAME\n";

        open(FILE, "<$entry") or die "Unable to open file $entry\n";

        my $line;
        $line = "*ppdFileName: ".$entry."\n";
        print (DB_FILE $line) or die "Unable to write in file $DB_FILE_NAME\n";

        while ( $line = readline(*FILE) )
        {
                #print "Line $line\n";

                if ( $line =~ /^*Manufacturer:.*/ ||
                     $line =~ /^*ModelName:.*/ ||
                     $line =~ /^*NickName:.*/ ||
                     $line =~ /^*ppdStatus:.*/ ||
                     $line =~ /^*pnpManufacturer:.*/ ||
                     $line =~ /^*pnpModel:.*/ ||
                     $line =~ /^*pnpCmd:.*/ ||
                     $line =~ /^*pnpDescr:.*/ )
                {
                        print DB_FILE $line;
                }

        }
        $line = "\n";
        print DB_FILE $line;

        close FILE;

        close(DB_FILE) or die "Unable to close file $DB_FILE_NAME\n";
}

