
/***************************************************************************
                          kaddprinterwizard.h  -  description
                             -------------------
    begin                : Mon Jan 31 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KUPS_ADDPRINTERWIZARD_H
#define KUPS_ADDPRINTERWIZARD_H


#include <qdialog.h>
#include <qlist.h>

#include "kap_main.h"


/**
  *@author jec
  */

class Kap_WizardPage;
class QHBoxLayout;
class QVBoxLayout;
class QGridLayout;
class QPushButton;
class QLabel;
class QWidgetStack;

class Kap_AddPrinterWizard : public QDialog
{
   Q_OBJECT
public: 
	Kap_AddPrinterWizard(QWidget *parent=0, const char *name=0);
	~Kap_AddPrinterWizard();

	void setWizardControl(Kap_Main::e_PageType start, Kap_Main::e_PageType stop, bool incl);

protected:
	void initWidgets();
	void initLayout();
	void makeConnection();
	
	bool initialize();
	

	Kap_Main::e_PageType getPrevPage();
	void addPrevPage(Kap_Main::e_PageType type);
	Kap_WizardPage* getPage(Kap_Main::e_PageType type);

	void setCurrentPage(Kap_Main::e_PageType type, bool addToPrev);

protected slots:
	void slotCancel();
	void slotPrev();
	void slotNext();

private:
	Kap_WizardPage* currentPage_;

	// Base pages
	Kap_WizardPage* explPage_;
	Kap_WizardPage* backendPage_;

	// Parallel pages
//	Kap_WizardPage* parallelSelector_;
	Kap_WizardPage* modelSelectorPage_;
	Kap_WizardPage* driverSelectorPage_;
	Kap_WizardPage* driverConfigPage_;
	Kap_WizardPage* bannerSelectorPage_;

	// Class of printers pages
	Kap_WizardPage* classSelectorPage_;

	// Local printer page
	Kap_WizardPage*	localSelectorPage_;
	Kap_WizardPage*	driverDetectPage_;

	// File selector page
	Kap_WizardPage*	fileSelectorPage_;

	// IPP pages
	Kap_WizardPage* ippSelectorPage_;
	Kap_WizardPage*	ippPrinterSelectorPage_;

	// SMB pages
	Kap_WizardPage* loginSelectorPage_;
	Kap_WizardPage* smbSelectorPage_;

	// LPD pages
	Kap_WizardPage*	lpdSelectorPage_;
	Kap_WizardPage*	lpdPrinterSelectorPage_;

	// Socket pages
	Kap_WizardPage* socketSelectorPage_;

	// Final pages
	Kap_WizardPage* nameSelectorPage_;
	Kap_WizardPage* confirmPage_;

	QLabel* 		 pageTitle_;
	QPushButton* cancelButton_;
	QPushButton* prevButton_;
	QPushButton* nextButton_;
	QWidgetStack*	widgetStack_;

	QList<Kap_Main::e_PageType> prevPageList_;

	// members for wizard control
	Kap_Main::e_PageType	startPage_, stopPage_;
	bool	inclusive_;
};

#endif
