/***************************************************************************
                          kap_driverconfig.h  -  description
                             -------------------
    begin                : Tue Feb 8 2000
    copyright            : (C) 2000 by Michael Goffioul
    email                : goffioul@imec.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KAP_DRIVERCONFIGPAGE_H
#define KAP_DRIVERCONFIGPAGE_H

#include <qwidget.h>
#include <kap_wizardpage.h>

#include <qtcups/globalppd.h>

/**
  *@author Michael Goffioul
  */

class QLabel;
class KBuffer;

class Kap_DriverConfigPage : public Kap_WizardPage
{
   Q_OBJECT
public:
	Kap_DriverConfigPage(QWidget *parent=0, const char *name=0);
	~Kap_DriverConfigPage();

	virtual bool canNextPage(QString& msg);
	virtual Kap_Main::e_PageType getNextPage(QString& message, bool fake = false);
	virtual Kap_Main::e_PageType getType() const;

	bool initialize();

protected slots:
	void slotTest();
        void slotSettings();

private:
	void loadPPD();
	KBuffer* loadPPDAsBuffer();

private:
	global_ppd_file_t	*ppd_;
        QString			ppdFileName_;
        QLabel			*manuLabel_;
        QLabel			*modelLabel_;
        QLabel			*driverLabel_;
};

#endif
