#ifndef KAP_DRIVERSELECTOR_H
#define	KAP_DRIVERSELECTOR_H

#include <qdialog.h>
#include <qlist.h>
#include <qdict.h>

class QListView;
class Kap_ModelItem;
class QPushButton;

class Kap_DriverSelector : public QDialog
{
	Q_OBJECT
public:
	Kap_DriverSelector(QWidget *parent = 0, const char *name = 0);
	~Kap_DriverSelector();

	void setModelList(QList<Kap_ModelItem> *list);
	Kap_ModelItem* selected();
        void setOptionsEnabled(bool on);

	static Kap_ModelItem* selectDriver(QList<Kap_ModelItem> *list, QWidget *parent, bool enableOptions = true);

protected slots:
	void optionsClicked();

protected:
	void initView();

private:
	QList<Kap_ModelItem>	*list_;
	QListView	*listview_;
	QDict<Kap_ModelItem>	dict_;
        QPushButton	*options_;
};

#endif
