
#include "kap_lpdinfopage.h"
#include "kap_lpdutil.h"
#include "kprinterdescription.h"
#include "kups.h"


#include <kapp.h>

Kap_LpdInfoPage::Kap_LpdInfoPage(QWidget *parent, const char *name)
	: Kap_MoreInfoPage(parent,name)
{
	setNumberOfInfos(2);
	setTitle(i18n("LPD daemon informations"));
	setLabel(0,i18n("Host"));
	setLabel(1,i18n("Queue"));
}

Kap_LpdInfoPage::~Kap_LpdInfoPage()
{
}

Kap_Main::e_PageType Kap_LpdInfoPage::getType() const
{
	return Kap_Main::LpdSelector;
}

Kap_Main::e_PageType Kap_LpdInfoPage::getNextPage(QString&, bool fake)
{
	if (fake) return Kap_Main::ModelSelector;

	KPrinterDescription	*descr = KPrinterDescription::get();
	descr->setLpdServer(QString(text(0)));
	if (QString(text(1)).isEmpty()) return Kap_Main::LpdPrinterSelector;
	else
	{
		descr->setLpdQueue(QString(text(1)));
		return Kap_Main::ModelSelector;
	}
}

bool Kap_LpdInfoPage::canNextPage(QString& msg)
{
	if (QString(text(0)).isEmpty())
	{ // host empty
		msg = i18n("You must specify a host name !");
		return false;
	}
	if (QString(text(1)).isEmpty())
	{ // queue empty
		if (!Kap_LpdUtil::hasLpdDaemon(text(0)))
		{
			msg = i18n("No LPD daemon running on this host !");
			return false;
		}
		const QStrList	*list = Kap_LpdUtil::getPrinterList(text(0));
		if (list->isEmpty())
		{
			msg = i18n("No printer detected for this host !");
			return false;
		}
		else return true;
	}
	else
	{ // verify queue
		if (!Kap_LpdUtil::isValidQueue(text(0),text(1)))
		{
			msg = i18n("Not a valid queue name !");
			return false;
		}
		return true;
	}
}
