
#include "kap_lpdprinterselector.h"
#include "kap_lpdutil.h"
#include "kprinterdescription.h"
#include "kups.h"

#include <kapp.h>

Kap_LpdPrinterSelector::Kap_LpdPrinterSelector(QWidget *parent, const char *name)
	: Kap_PrinterSelector(parent,name)
{
	setTitle(i18n("Choose a printer"));
}

Kap_LpdPrinterSelector::~Kap_LpdPrinterSelector()
{
}

Kap_Main::e_PageType Kap_LpdPrinterSelector::getType() const
{
	return Kap_Main::LpdPrinterSelector;
}

Kap_Main::e_PageType Kap_LpdPrinterSelector::getNextPage(QString& msg, bool fake)
{
	if (fake) return Kap_Main::ModelSelector;

	KPrinterDescription	*descr = KPrinterDescription::get();
	descr->setLpdQueue(QString(getPrinter()));
	return Kap_Main::ModelSelector;
}

bool Kap_LpdPrinterSelector::canNextPage(QString& msg)
{
	if (!getPrinter())
	{
		msg = i18n("Select a printer !");
		return false;
	}
	return true;
}

bool Kap_LpdPrinterSelector::initialize()
{
	KPrinterDescription	*descr = KPrinterDescription::get();
	const QStrList	*list = Kap_LpdUtil::getPrinterList(descr->getSMBServer().data(),false);
	clearPrinters();
	QStrListIterator	it(*list);
	for (;it.current();++it)
		addPrinter(it.current());
	return true;
}
