#ifndef KINSTANCEMANAGER_H
#define KINSTANCEMANAGER_H

#include <qdatetime.h>
#include <qlist.h>

#include <cups/cups.h>

class KPrinterInstance;

class KInstanceManager
{
public:
	KInstanceManager();
	~KInstanceManager();

	static KInstanceManager* get();
	static void release();

	bool refresh();
	KPrinterInstance* findInstance(const QString& printer, const QString& instance);
	QList<KPrinterInstance> getInstancesForPrinter(const QString& printer);
	bool saveInstances();
	QString getPrinterDefaultInstance();

	void setLastError(const QString& msg) { errormsg_ = msg; }
	const QString& getLastError() { return errormsg_; }
	bool createInstance(const QString& pr, const QString& inst);
	bool copyInstance(const QString& pr, const QString& inst, const QString& newinst);
	bool removeInstance(const QString& pr, const QString& inst);
	bool setDefaultInstance(const QString& pr, const QString& inst);
	bool editInstance(const QString& pr, const QString& inst);
	bool testInstance(const QString& pr, const QString& inst);

protected:
//	bool loadInstanceFile(const QString& filename, int& num_dest, cups_dest_t **dests);
	bool loadInstanceFile(const QString& filename);
	bool writeInstanceFile(const QString& filename);
	void clearDefaultInstance();

private:
	static KInstanceManager	*unique_;

	QDateTime	lastcheck_;
	QList<KPrinterInstance>	instances_;
	QString	errormsg_;
	QString defaultprinter_;
};

#endif
