/***************************************************************************
                          kjobhelper.h  -  description
                             -------------------
    begin                : Wed Dec 20 2000
    copyright            : (C) 2000 by Michael Goffioul
    email                : goffioul@imec.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KJOBHELPER_H
#define KJOBHELPER_H

#include <cups/ipp.h>

#include "kups_helper.h"
#include "kjob.h"

/**
  *@author Michael Goffioul
  */

class KJobHelper : public Kups_Helper  {
public: 
	KJobHelper();
	~KJobHelper();

	static KJobHelper* get();

	void setAttribute(KJob* job, ipp_attribute_t* attr);

	bool sendJobCommand(KJob *job, KJob::Command command);
	bool sendJobCommand(KJob *job, KJob::Command command, KPrinter *printer);

protected:
	bool doJobCommand(KJob *job, KJob::Command command);
	bool moveJob(KJob *job, KPrinter *printer);

private:
	static KJobHelper* unique_;
};

#endif
