#include "kpp_generalpage.h"

#include <qlineedit.h>
#include <qlabel.h>
#include <qlayout.h>
#include <klocale.h>

#include "kprinterdescription.h"

Kpp_GeneralPage::Kpp_GeneralPage(QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	desc_ = 0;
	initWidget();
}

Kpp_GeneralPage::~Kpp_GeneralPage()
{
}

void Kpp_GeneralPage::setInfos(KPrinterDescription *d)
{
	desc_ = d;
	name_->setText(d->getName());
	description_->setText(d->getDescription());
	location_->setText(d->getLocation());
}

void Kpp_GeneralPage::collectInfos(KPrinterDescription *d)
{
	d->setName(name_->text());
	d->setDescription(description_->text());
	d->setLocation(location_->text());
}

void Kpp_GeneralPage::initWidget()
{
	name_ = new QLineEdit(this);
	name_->setFixedHeight(name_->sizeHint().height());
	description_ = new QLineEdit(this);
	description_->setFixedHeight(description_->sizeHint().height());
	location_ = new QLineEdit(this);
	location_->setFixedHeight(location_->sizeHint().height());

	QLabel	*l1 = new QLabel(i18n("Name:"), this);
	l1->setFixedHeight(l1->sizeHint().height());
	l1->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
	QLabel	*l2 = new QLabel(i18n("Description:"), this);
	l2->setFixedHeight(l2->sizeHint().height());
	l2->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
	QLabel	*l3 = new QLabel(i18n("location:"), this);
	l3->setFixedHeight(l3->sizeHint().height());
	l3->setAlignment(Qt::AlignRight|Qt::AlignVCenter);

	QHBoxLayout	*mainLayout_ = new QHBoxLayout(this, 10);
	QVBoxLayout	*leftLayout_ = new QVBoxLayout();
	QVBoxLayout	*rightLayout_ = new QVBoxLayout();

	mainLayout_->addLayout(leftLayout_,1);
	mainLayout_->addLayout(rightLayout_,3);
	leftLayout_->addWidget(l1);
	leftLayout_->addWidget(l2);
	leftLayout_->addWidget(l3);
	rightLayout_->addWidget(name_);
	rightLayout_->addWidget(description_);
	rightLayout_->addWidget(location_);
}
