/***************************************************************************
                          kups_testpagegenerator.cpp  -  description
                             -------------------
    begin                : Sat Jan 22 2000
    copyright            : (C) 2000 by jec
    email                : cuendet@linkvest.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <unistd.h>

#include <cups/cups.h>

#include <qpainter.h>
#include <qprinter.h>
#include <qregexp.h>
#include <qmessagebox.h>

#include <kapp.h>
#include <klocale.h>

#include "kups_testpagegenerator.h"

#include "kprintermanager.h"
#include "kprinter.h"
#include "kbuffer.h"

	

KBuffer Kups_TestPageGenerator::genPage_;
bool Kups_TestPageGenerator::init_ = false;


Kups_TestPageGenerator::Kups_TestPageGenerator()
{
}
Kups_TestPageGenerator::~Kups_TestPageGenerator()
{
}

void Kups_TestPageGenerator::init()
{
	if (init_)
	{
		return;
	}

	//open file;
	//basicPage_ = ...

	init_ = true;
}

bool Kups_TestPageGenerator::printPage(QWidget* parent, KPrinter* printer)
{
	const KBuffer& page = Kups_TestPageGenerator::getPage(printer);
	if (page.size() == 0)
	{
		QMessageBox::critical(parent, i18n("Print test page"), i18n("Unable to find a valid test page. Check your options."), QMessageBox::Ok|QMessageBox::Default, 0);
		return false;
	}
	if (!printer->printBuffer(page))
	{
		if (parent != 0)
		{
			QMessageBox::critical(parent,i18n("Print test page"),KPrinterManager::getLastError(),QMessageBox::Ok|QMessageBox::Default,0);
		}
		return false;
	}
	else if (parent)
	{
		QMessageBox::information(parent, i18n("Test printer"), i18n("Test page successfully sent to printer \"%1\"").arg(printer->getName()), QMessageBox::Ok|QMessageBox::Default, 0);
	}
	return true;
}

const KBuffer& Kups_TestPageGenerator::getPage(KPrinter* printer)
{
	init();

	genPage_.assign( getBasicPage() );
	if (printer)
	{

	QString opsysName = "Linux";
	QString printingSystem = "CUPS v";
	QString str;str.sprintf("%1.2f", CUPS_VERSION);
	printingSystem += str;
	QString manufacturer = "Easy software";
	QString hostname = "<unknown>";

	QString printerName = "<unknown>";
	QString isColor = "No";
	QString state = "Ok";
	QString location = "<not specified>";
	QString ippURI = "<unknown>";
	QString localURI = "<unknown>";



	// Hostname
	char h[256];
	if (0 == gethostname(h, 256))
	{
		hostname = h;	
	}
	else
	{
		hostname = "<unknown>";
	}
	

	// Printer name	
	printerName = printer->getName();
	if (printer->isDefault())
	{
		printerName += " <Default>";
	}
	

		
	// Color ?
	if (printer->isColor())
	{
		isColor = "Yes";
	}
	

	// Printer state	
	if (!printer->getStateReason().isEmpty())
	{
		state = printer->getStateReason().data();
	}


	
	// Location	
	if (!printer->getLocation().isEmpty())
	{
		location = printer->getLocation();
	}
	


	
	// IPP URI	
	ippURI = printer->getIppURI();
	
	
	// Local URI
	localURI = printer->getLocalURI();

	
	
	// Operating system
	genPage_.replace("<#opSys#>", opsysName );
	// Printing system
	genPage_.replace("<#printingSystemVer#>", printingSystem );
	// Manufacturer
	genPage_.replace("<#manufacturer#>", manufacturer );
	// Hostname
	genPage_.replace("<#hostname#>", hostname );
	// Printer name
	genPage_.replace("<#printerName#>", printerName );
	// Color ?
	genPage_.replace("<#isColor#>", isColor );
	// Printer state reason
	genPage_.replace("<#printerState#>", state );
	// Physical location
	genPage_.replace("<#physicalLocation#>", location );
	// Local URI
	genPage_.replace("<#localURI#>", localURI );
	// IPP URI
	genPage_.replace("<#ippURI#>", ippURI );

	} // if (printer)

	genPage_.dump("/tmp/test_file2.ps");
	
	return genPage_;
}


