#ifndef CUPSLIST_H
#define	CUPSLIST_H

#include <qwidget.h>

class QPushButton;
class QListView;
class QListViewItem;

class CupsListBox : public QWidget
{
	Q_OBJECT;
public:
	CupsListBox(QWidget *parent = 0, const char *name = 0);
	CupsListBox(int columns, QWidget *parent = 0, const char *name = 0);
	~CupsListBox();

	QString text(int index, int column = 0) const;
	void insertItem(const QString& str, int index = -1);
	void insertItem(const QStringList& strs, int index = -1);
	void setAddMessage(const QString& msg, int index = -1);
	int count() const;
	void setColumnText(int column, const QString& txt);

protected slots:
	void addClicked();
	void removeClicked();

protected:
	void createView(int columns);
	void createLayout();
	void createButtons();
	void init(int columns);
	QListViewItem* findItemAtIndex(int i) const;

private:
	QListView	*list_;
	QPushButton	*add_;
	QPushButton	*remove_;
	QStringList	addmsg_;
	int		columns_;
};

#endif
